#include <stdio.h>
#include <stdlib.h>

void arrayInit(int *array, unsigned long long int size){
    unsigned long int i;
    for(i=0;i<size;i++){
        array[i] = 0;
    }
}

int main()
{
    unsigned long long int brojKarata, brojParova;
    scanf("%llu %llu", &brojKarata, &brojParova);

    int* karte;
    karte = calloc(brojKarata-1, sizeof(int));

    unsigned int nextFreeColor = 1;
    unsigned int par1, par2;
    unsigned long long int i;
    unsigned long int coloredCards = 0;
    arrayInit(karte, brojKarata);
    for(i=0;i<brojParova;i++){
        scanf("%d %d", &par1, &par2);
        par1--;
        par2--;
        if(karte[par1] != 0 && karte[par2] != karte[par1]){  //ako se prva razlikuje u boji od belo
            karte[par2] = karte[par1];
            coloredCards++;
        } else if(karte[par2] != 0 && karte[par1] != karte[par2]){ //ako se druga razlikuje od belog
            karte[par1]= karte[par2];
            coloredCards++;
        } else if(karte[par1] == 0 && karte[par2] == 0){
            karte[par1] = nextFreeColor;
            karte[par2] = nextFreeColor;
            coloredCards+=2;
            nextFreeColor++;
        }
    }

    unsigned long int result = brojKarata - coloredCards + nextFreeColor - 1;
    printf("%lu", result);

    return 0;
}