using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Karte
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] a = Console.ReadLine().Split(' ');
            long N = long.Parse(a[0]);
            long M = long.Parse(a[1]);
            Dictionary<long, List<long>> parovi = new Dictionary<long, List<long>>();
            long moguceKombinacije = N;
            for (long i = 0; i < M; i++)
            {
                a = Console.ReadLine().Split(' ');
                long karta1 = long.Parse(a[0]);
                long karta2 = long.Parse(a[1]);
                bool karta1Postoji = parovi.ContainsKey(karta1);
                bool karta2Postoji = parovi.ContainsKey(karta2);
                if (karta1Postoji && karta2Postoji)
                    spojParove(parovi, karta1, karta2);
                else if (karta1Postoji)
                {
                    if (parovi[karta1].Contains(karta2)) continue;
                    parovi[karta1].Add(karta2);
                }
                else if (karta2Postoji)
                {
                    if (parovi[karta2].Contains(karta1)) continue;
                    parovi[karta2].Add(karta1);
                }
                else parovi.Add(karta1, new List<long>() { karta2 });
            }
            foreach (var i in parovi)
                moguceKombinacije -= i.Value.Count;
            Console.WriteLine(1 + moguceKombinacije);
            Console.ReadKey();
        }

        static void spojParove(Dictionary<long, List<long>> parovi, long a, long b)
        {
            List<long> spojeniNiz = parovi[a];
            spojeniNiz.AddRange(parovi[b]);
            parovi.Remove(b);
            parovi[a] = spojeniNiz;
        }
    }
}