using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Karte
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] a = Console.ReadLine().Split(' ');
            long N = long.Parse(a[0]);
            long M = long.Parse(a[1]);
            List<List<long>> parovi = new List<List<long>>();
            for (long i = 0; i < M; i++)
            {
                a = Console.ReadLine().Split(' ');
                long k1 = long.Parse(a[0]);
                long k2 = long.Parse(a[1]);
                int postoji1 = -1;
                int postoji2 = -1;
                for (int j = 0; j < parovi.Count; j++)
                {
                    if (postoji1 == -1)
                        if (binarySearch(k1, parovi[j])) postoji1 = j;
                    if (postoji2 == -1)
                        if (binarySearch(k2, parovi[j])) postoji2 = j;
                    if (postoji1 != -1 && postoji2 != -1) break;
                }
                if (postoji1 == -1 && postoji2 == -1)
                    parovi.Add(new List<long>() { k1 < k2 ? k1 : k2, k1 < k2 ? k2 : k1 });
                else if (postoji1 == -1)
                    binaryInsert(k1, parovi[postoji2]);
                else if (postoji2 == -1)
                    binaryInsert(k2, parovi[postoji1]);
                else if (postoji1 != postoji2)
                {
                    parovi[postoji1].AddRange(parovi[postoji2]);
                    parovi.RemoveAt(postoji2);
                    parovi[postoji1].Sort();
                }
                else continue;
            }
            long kombinacije = N;
            foreach (var l in parovi) kombinacije -= l.Count - 1;
            Console.WriteLine(kombinacije);
        }

        static bool binarySearch(long item, List<long> list)
        {
            int x = 0;
            int y = list.Count - 1;
            while (x != y)
            {
                int mid = (x + y) / 2;
                if (list[mid] < item)
                    x = mid + 1;
                else if (item < list[mid])
                    y = mid;
                else x = y = mid;
            }
            return list[x] == item;
        }

        static void binaryInsert(long item, List<long> list)
        {
            int x = 0;
            int y = list.Count - 1;
            while (x != y)
            {
                int mid = (x + y) / 2;
                if (list[mid] < item)
                    x = mid + 1;
                else if (item < list[mid])
                    y = mid;
                else x = y = mid;
            }
            list.Insert(1 + x, item);
        }
    }
}