#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int main(){

    int n, m;
    cin >> n >> m;

    vector<bool> bio(n, false);
    vector<vector<int> > g(n);

    int a, b;

    for(int i = 0; i < m; i++){
        cin >> a >> b;

        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);

    }

    int resenje = 0;

    for(int i = 0; i < n; i++){
        if(!bio[i]){
            resenje++;

            queue<int> q;
            q.push(i);

            while(!q.empty()){

                int c = q.front();
                q.pop();

                if(bio[c])
                    continue;

                bio[c] = true;

                for(int i = 0; i < g[c].size(); i++)
                    q.push(g[c][i]);

            }

        }
    }

    cout << resenje << endl;

    return 0;
}