#include <iostream>
#include <vector>

using namespace std;

vector<vector<int> > gr;
vector<int> bio;

void dfs(int x){
    bio[x]=1;
    for(int i = 0 ;i < gr[x].size(); i++){
        if(!bio[gr[x][i]]) dfs(gr[x][i]);
    }
}

int main()
{
    int n, m, a, b;
    cin >> n >> m;
    bio.insert(bio.begin(), n, 0);
    vector<int> vi;
    gr.insert(gr.begin(), n, vi);
    int k=0;
    for(int i = 0; i < m; i++){
        cin >> a >> b;
        gr[b-1].push_back(a-1);
        gr[a-1].push_back(b-1);
    }
    for(int i = 0; i<n; i++){
        if(!bio[i]){
            dfs(i);
            k++;
        }
    }
    cout << k << endl;
    return 0;
}